# frozen_string_literal: true

require "is/inspectable"

module Core
  module Pipeline
    module Actions
      # [public] A pipeline action defined as a method.
      #
      class Method < Action
        include Is::Inspectable

        def initialize(name = nil, before: nil, after: nil, context: nil)
          @method = nil

          super(name, before: before, after: after, context: context)
        end

        # [public]
        #
        def finalize(context)
          case @context
          when NilClass
            context.instance_method(@name)
            @name
          else
            @context.method(@name).to_proc
          end
        end
      end
    end
  end
end
